import sys
import re
import components

class FormParser(object):
	def __init__(self):
		self.constants = []
		self.originals = []
		self.newforms = []
		
	def addForm(self, form):
		self.originals.append(form)
		
	def addSetForms(self, forms):
		self.extend(forms)
		
	def parseForms(self):
		i = len(self.constants)
		for f in self.originals:
			values1 = list(set(re.findall('<([0-9]+);([0-9]+)>', f)))
			values = list(set(re.findall('<([0-9]+\.[0-9]+);([0-9]+)>', f)))
			for v in values1:
				values.append(((v[0]+".0", v[1])))
			nf = f
			for v in values:
				self.constants.append(["c"+str(i), v])
				nf = nf.replace("<"+v[0]+";"+v[1]+">", "c"+str(i))
				i = i+1 
			self.newforms.append(nf)
		return self.newforms
	
	def getConstants(self):
		return self.constants
	
	def declareConsts(self):
		declarations = ""
		for c in self.constants:
			declarations = declarations + """
			(declare-const """ + c[0] +""" Pair)
			(assert (= """ + c[0] + """ (store (store """ + c[0] + """ 1 """+ c[1]+""") 2 """+c[2]+""".0)))"""
		return declarations
			
			

			
	